<?php

 class Attachment
 {
  var $filename;
  var $ownerType; // NOTE, PAGE
  var $ownerID;
  var $size;
  var $description;
  var $createdDate;
  var $createdByUserID;
  var $isPublic;

  function Attachment()
  {
  }

  function isPublic()
  {
   if($this->isPublic=="0")
   {
    return false;
   }
   return true;
  }

  function setPublic($ispublic)
  {
   if($ispublic)
   {
    $this->isPublic = "1";
   }
   else
   {
    $this->isPublic = "0";
   }
  }

  function load()
  {
   global $g_attachdir;

   $path = $g_attachdir;

   if($this->ownerType=="NOTE")
   {
    $path.= "/note";
   }
   else if($this->ownerType=="PAGE")
   {
    $path.= "/page";
   }
   else
   {
    return false;
   }

   if(!is_numeric($this->ownerID))
   {
    return false;
   }

   if($this->filename=="")
   {
    return false;
   }

   $path.= "/".$this->ownerID;


   $fileinfo = $path."/".$this->filenameToFileInfo($this->filename);
   $path.= "/".$this->filename;

   if(!file_exists($path) || !file_exists($fileinfo))
   {
    return false;
   }


   $handle = fopen($fileinfo,"r");

   if($handle===false)
   {
    return false;
   }

   $this->isPublic = "1";

   while(!feof($handle))
   {
    $in = trim(fgets($handle, 4096));

    if($in!="" && $in[0]!=";")
    {
     $pos = strpos($in,"=");
     $label = substr($in,0,$pos);
     $value = substr($in,$pos+1);

     if($label=="size")
     {
      $this->size = $value;
     }
     else if($label=="description")
     {
      $this->description = $value;
     }
     else if($label=="createdDate")
     {
      $this->createdDate = $value;
     }
     else if($label=="createdByUserID")
     {
      $this->createdByUserID = $value;
     }
     else if($label=="isPublic")
     {
      $this->isPublic = $value;
     }

    }

   }

   fclose($handle);

   return true;
  }

  function store()
  {
   global $g_attachdir;

   if(!is_numeric($this->createdDate) || $this->createdDate==0)
   {
    $this->createdDate = time();
   }

   $path = $g_attachdir;

   if($this->ownerType=="NOTE")
   {
    $path.= "/note";
   }
   else if($this->ownerType=="PAGE")
   {
    $path.= "/page";
   }
   else
   {
    return false;
   }

   if(!is_numeric($this->ownerID))
   {
    return false;
   }

   if($this->filename=="")
   {
    return false;
   }

   $path.= "/".$this->ownerID;

   if(!file_exists($path))
   {
    return false;
   }

   $path.="/".$this->filenameToFileInfo($this->filename);

   $handle = fopen($path,"w");

   if($handle===false)
   {
    return false;
   }

   fwrite($handle,"filename=".$this->filename."\n");
   fwrite($handle,"ownerType=".$this->ownerType."\n");
   fwrite($handle,"ownerID=".$this->ownerID."\n");
   fwrite($handle,"size=".$this->size."\n");
   fwrite($handle,"description=".$this->description."\n");
   fwrite($handle,"createdDate=".$this->createdDate."\n");
   fwrite($handle,"createdByUserID=".$this->createdByUserID."\n");
   fwrite($handle,"isPublic=".$this->isPublic."\n");

   fclose($handle);

   @chmod($path,0666);

   return true;

  }

  function remove()
  {
   global $g_attachdir;

   $path = $g_attachdir;

   if($this->ownerType=="NOTE")
   {
    $path.= "/note";
   }
   else if($this->ownerType=="PAGE")
   {
    $path.= "/page";
   }
   else
   {
    return false;
   }

   if(!is_numeric($this->ownerID))
   {
    return false;
   }

   if($this->filename=="")
   {
    return false;
   }

   $path.= "/".$this->ownerID;

   $fileinfo = $path."/".$this->filenameToFileInfo($this->filename);
   $path.= "/".$this->filename;

   @unlink($fileinfo);
   @unlink($path);

  }

  function filenameToFileInfo($filename)
  {
   $pathinfo = pathinfo($filename);
   $type = $pathinfo['extension'];

   if($type!="")
   {
    $name = substr($filename,0,strlen($filename)-strlen($type)-1);
    return $name."_".$type.".fileinfo";
   }
   else
   {
    $name = $filename;
    return $name.".fileinfo";
   }

  }

 }

?>
