<?php

 $g_attachments = new Attachments();

 class Attachments
 {
  function Attachments()
  {
  }

  function getAttachmentByFilename($filename,$ownerType,$ownerID)
  {
   $attachment = new Attachment();
   $attachment->filename = $filename;
   $attachment->ownerType = $ownerType;
   $attachment->ownerID = $ownerID;

   $result = $attachment->load();

   if($result==false)
   {
    return false;
   }

   return $attachment;
  }

  function listAttachmentsByNoteID($noteid)
  {
   global $g_attachdir;

   if(!is_numeric($noteid))
   {
    return false;
   }
  
   $path = "$g_attachdir/note/$noteid";

   return $this->listAttachments($path,"NOTE",$noteid);
  }

  function listAttachmentsByPageID($pageid)
  {
   global $g_attachdir;

   if(!is_numeric($pageid))
   {
    return false;
   }
  
   $path = "$g_attachdir/page/$pageid";

   return $this->listAttachments($path,"PAGE",$pageid);
  }

  function listAttachments($path,$ownerType,$ownerID)
  {
   $list = array();

   if(!is_dir($path))
   {
    return false;
   }

   $files = scandir($path);

   for($i=0;$i<count($files);$i++)
   {
    $file = $files[$i];

    if($file!="." && $file!=".." && $file!="index.html" && $file!="index.php")
    {
     $pathinfo = pathinfo($file);

     $type = $pathinfo["extension"];

     if($type!="fileinfo")
     {
      $attachment = new attachment();
      $attachment->filename = $file;
      $attachment->ownerType = $ownerType;
      $attachment->ownerID = $ownerID;
      $result = $attachment->load();
      if($result)
      {
       $list[$file] = $attachment;
      }
     }
    }

   }
   return $list;
  }

 function getNoteAttachmentByFilename($noteid,$filename)
 {
  if(!is_numeric($noteid) || $filename=="")
  {
   return false;
  }

  $attachment = new Attachment();
  $attachment->filename = $filename;
  $attachment->ownerType = "NOTE";
  $attachment->ownerID = $noteid;
 
  return $attachment->load();
 }

 function getPageAttachmentByFilename($pageid,$filename)
 {
  if(!is_numeric($pageid) || $filename=="")
  {
   return false;
  }

  $attachment = new Attachment();
  $attachment->filename = $filename;
  $attachment->ownerType = "PAGE";
  $attachment->ownerID = $pageid;
 
  return $attachment->load();
 }

 function deleteAttachmentsByNoteID($noteid)
 {
  global $g_attachdir;

  if(!is_numeric($noteid))
  {
   return false;
  }

  // first remove attachments as if the fileinfo is stored in a database
  $attachments = $this->listAttachmentsByNoteID($noteid);

  if(is_array($attachments))
  {
   foreach($attachments AS $filename => $attachment)
   {
    $attachment->remove();
   }
  }

  // recursively remove the directory
  $path = "$g_attachdir/note/$noteid";
  rrmdir($path);
  return true;
 }

 function deleteAttachmentsByPageID($pageid)
 {
  global $g_attachdir;

  if(!is_numeric($pageid))
  {
   return false;
  }

  // first remove attachments as if the fileinfo is stored in a database
  $attachments = $this->listAttachmentsByPageID($pageid);

  if(is_array($attachments))
  {
   foreach($attachments AS $filename => $attachment)
   {
    $attachment->remove();
   }
  }

  // recursively remove the directory
  $path = "$g_attachdir/page/$pageid";
  rrmdir($path);
  return true;
 }



}
