<?php

 $g_forums = new Forums();

 class Forums
 {

  function Forums()
  {
  }

  function deleteForumByID($forumid)
  {
   global $db_database,$g_threads;

   $report = "";
  
   $forum = $this->getForumByID($forumid);

   if(is_object($forum))
   {
    if($this->hasChildren($forumid))
    {
     $report.= "This forum cannot be deleted";
    }
    else
    {
     $db_database->startTransaction();

     $sql = "SELECT ThreadID FROM Thread WHERE ForumID='$forumid'";

     $result = $db_database->query($sql);

     while(is_array($array = $db_database->fetch_array($result)))
     {
      $threadid = $array["ThreadID"];
      $report.=$g_threads->deleteThread($threadid);
     }

     $summary.="Deleting Forum $forumid <BR />";
     $sql = "DELETE FROM Forum WHERE ForumID='$forumid'";
     $result = $db_database->query($sql);

     $db_database->endTransaction();
    }
   }
   else
   {
    $report.= "No such forum";
   }

   return $report;
  }

  function hasChildren($forumid)
  {
   global $db_database;

   $sql = "SELECT COUNT(ForumID) as count FROM Forum WHERE ParentForumID='$forumid'";

   $result = $db_database->query($sql);

   $array = $db_database->fetch_array($result);
   $count = $array["count"];

   if(!is_numeric($count))
   {
    return true;
   }

   if($count==0)
   {
    return false;
   }

   return true;
  }

  function getLastCommentByForumID($forumid)
  {
   global $db_database,$g_user;

   if(is_object($g_user) && $g_user->access("MODERATOR"))
   {
    $hidden = "";
   }
   else
   {
    $hidden = "Thread.IsHidden = '0' AND ";
   }

   $sql = "
SELECT 
 ForumComment.ForumID AS ForumID, 
 ForumComment.CommentID AS CommentID, 
 Comment.CreatedByUserID AS LastByUserID, 
 Comment.CreatedDate AS LastDate, 
 User.Username AS LastByUsername, 
 ThreadComment.ThreadID AS ThreadID
FROM
(
 SELECT 
  WithForum.ForumID AS ForumID, 
  MAX(WithForum.CommentID) AS CommentID 
 FROM
 (
  SELECT 
   MaxComment.ThreadID, 
   MaxComment.CommentID, 
   Thread.ForumID
  FROM
  (
   SELECT 
    ThreadID, 
    MAX(ThreadComment.CommentID) AS CommentID 
   FROM ThreadComment
   GROUP BY ThreadComment.ThreadID
  ) As MaxComment, Thread
  WHERE
   $hidden
   MaxComment.ThreadID = Thread.ThreadID
 ) AS WithForum
 GROUP BY WithForum.ForumID
) AS ForumComment,Comment,User,ThreadComment
WHERE 
 ForumComment.CommentID = Comment.CommentID
 AND User.UserID = Comment.CreatedByUserID
 AND ThreadComment.CommentID = ForumComment.CommentID
 AND ForumComment.ForumID = '$forumid'";

   $result = $db_database->query($sql);
   $array = $db_database->fetch_array($result);
   return $array;
  }

  function getCommentCountByForumID($forumid)
  {
   global $db_database,$g_user;

   if(is_object($g_user) && $g_user->access("MODERATOR"))
   {
    $hidden = "";
   }
   else
   {
    $hidden = "Thread.IsHidden = '0' AND ";
   }

   $sql = "
SELECT 
 SUM(SubCommentCount) AS count, 
 ForumID
FROM (
 SELECT 
  Count(ThreadComment.CommentID) AS SubCommentCount,
  Thread.ThreadID AS ThreadID, 
  Thread.ForumID AS ForumID 
 FROM 
  ThreadComment,Thread 
 WHERE 
  $hidden
  ThreadComment.ThreadID = Thread.ThreadID AND 
  ThreadComment.CommentID!=Thread.CommentID 
 GROUP BY Thread.ThreadID 
 ORDER BY ForumID) AS InnerCount
WHERE ForumID = '$forumid' GROUP BY ForumID";

   $result = $db_database->query($sql);

   $array = $db_database->fetch_array($result);

   if(!is_array($array))
   {
    $count = 0;
   }
   else
   {
    $count = $array["count"];
   }

   return $count;
  }

  function getThreadCountByForumID($forumid)
  {
   global $db_database,$g_user;

   if(is_object($g_user) && $g_user->access("MODERATOR"))
   {
    $hidden = "";
   }
   else
   {
    $hidden = "Thread.IsHidden = '0' AND ";
   }

   $sql = "SELECT COUNT(ThreadID) AS count FROM Thread WHERE $hidden ForumID='$forumid'";

   $result = $db_database->query($sql);

   $array = $db_database->fetch_array($result);
   $count = $array["count"];

   return $count;
  }


  function getForumByID($forumid)
  {
   $_forum = new Forum();
   $_forum->forumID = $forumid;
   $res=$_forum->load();

   if($res===false)
   {
    return false;
   }
   return $_forum;
  }

  function listForums($onlyparents=true,$ignore=0,$parentid=0,$level=0)
  {
   $result = array();

   $forums = $this->getParentList($onlyparents,$parentid);

   foreach($forums AS $id => $forum)
   {
    $forum->level = $level;
    if($id!=$ignore)
    {
     $result[$id] = $forum;
     $subresult = $this->listForums($onlyparents,$ignore,$id,$level+1);
     foreach($subresult AS $_id => $_forum)
     {
      $result[$_id]=$_forum;
     }
    }
   }

   return $result;
  }

  function getParentList($onlyparents=true,$parentid=0)
  {
   global $db_database,$g_user;

   if(!is_object($g_user))
   {
    $accesslevelid = 0;
   }
   else
   {
    $accesslevelid = $g_user->accessLevelID;
   }

   $sql = "SELECT * FROM Forum WHERE ParentForumID='$parentid' AND ReadAccessLevelID<='$accesslevelid' ";
   if($onlyparents)
   {
    $sql.= "AND IsParent='1' ";
   }
   $sql.= "ORDER BY ";
   if(!$onlyparents) // Always proritize nodes
   {
    $sql.= "ISParent DESC, ";
   }
   $sql.= "SortOrder";

   $result = $db_database->query($sql);
   $forums = $this->resultIntoArray($result);
   return $forums;
  }

  function getAllForumsByParentID($parentid)
  {
   global $db_database,$g_user;

   if(!is_numeric($parentid))
   {
    $parentid = 0;
   }

   if(!is_object($g_user))
   {
    $accesslevelid = 0;
   }
   else
   {
    $accesslevelid = $g_user->accessLevelID;
   }

   $sql = "SELECT * FROM Forum WHERE ParentForumID='$parentid' AND ReadAccessLevelID<='$accesslevelid' ORDER BY SortOrder";

   $result = $db_database->query($sql);
   $forums = $this->resultIntoArray($result);
   return $forums;
  }

  function resultIntoArray($result)
  {
   global $db_database;

   $list = array();

   while(is_array($array = $db_database->fetch_array($result)))
   {
    $forum = new Forum();
    $forum->insertArray($array);
    $list[$forum->forumID] = $forum;
   }

   return $list;
  }

 }

?>
